#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	VF.setupField(ofGetWidth()/10,ofGetHeight()/10,ofGetWidth(), ofGetHeight());
	//VF.randomizeField(2.0);
	
	for ( int j = 0; j < ofGetHeight()/10; j++ ){
		for ( int i = 0; i < ofGetWidth()/10; i++ ){
			pixel myPix;
			myPix.pos.set( i * 10, j * 10 );
			myPix.size.set( 10, 10 );
			
			//printf("ATAN2: %f \n", atan2(VF.field[i*j+i].x, VF.field[ i*j+i ].y)*RAD_TO_DEG);
			
			myPix.hue = ofMap(atan2(VF.field[i*j+i].x, VF.field[ i*j+i ].y)*RAD_TO_DEG, -360, 360, 0, 360);
			
			myPix.sat = 1.0;
			myPix.val = ofMap(VF.field[i*j+i].length(), 0, 10, 0, 1);
			myPix.color.r = HSVtoRGB( myPix.hue, myPix.sat, myPix.val ).r;
			myPix.color.g = HSVtoRGB( myPix.hue, myPix.sat, myPix.val ).g;
			myPix.color.b = HSVtoRGB( myPix.hue, myPix.sat, myPix.val ).b;
			
			pixels.push_back(myPix);
		}
	}
	
	
	drawingStyle = 0;
	bFade = true;
}

//--------------------------------------------------------------
void testApp::update(){
	
	for ( int i = 0; i < pixels.size(); i++ ){
		pixels[ i ].hue = ofMap(atan2(VF.field[i].x, VF.field[ i ].y)*RAD_TO_DEG, -180, 180, 0, 360);
		pixels[ i ].sat = 1.0;
		pixels[ i ].val = ofMap(VF.field[i].length(), 0, 10, 0, 1);
		pixels[ i ].color.r = HSVtoRGB( pixels[ i ].hue, pixels[ i ].sat, pixels[ i ].val ).r;
		pixels[ i ].color.g = HSVtoRGB( pixels[ i ].hue, pixels[ i ].sat, pixels[ i ].val ).g;
		pixels[ i ].color.b = HSVtoRGB( pixels[ i ].hue, pixels[ i ].sat, pixels[ i ].val ).b;	}

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	
	/*for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		
		// get the force from the vector field: 
		ofxVec2f frc;
		frc = VF.getForceFromPos(particles[i].pos.x, particles[i].pos.y);
		particles[i].addForce(frc.x, frc.y);
		particles[i].addDampingForce();
		particles[i].update();
	}
	
	
	if (bFade == true) VF.fadeField(0.99f);
	 */

}

//--------------------------------------------------------------
void testApp::draw(){
	
	ofEnableAlphaBlending();
	
	ofSetColor(0x000000);
	
	for (int i = 0; i < pixels.size(); i++){
		pixels[ i ].draw();
	}
	
	ofSetColor(0,130,130, 200);
	ofRect(30,30,300,75);
	ofSetColor(255,255,255, 230);
	ofDrawBitmapString("space to clear\nchange drawing mode 'a'\ntoggle fade 'f'", 50, 50);
	
	ofSetColor(0,130,130, 200);
	//VF.draw();
	
	ofSetColor(255,255,130, 230);
	switch (drawingStyle){
		case 0: ofDrawBitmapString("drawing mode: inward", 50, 90);
			break;
		case 1: ofDrawBitmapString("drawing mode: outward", 50, 90);
			break;
		case 2: ofDrawBitmapString("drawing mode: clockwise", 50, 90);
			break;
		case 3: ofDrawBitmapString("drawing mode: counter-clockwise", 50, 90); 
			break;
	}	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	if (key == ' '){
		VF.clear();
	} else if (key == 'a'){
		drawingStyle ++;
		drawingStyle %= 4;
	} else if (key == 'f'){
		bFade = !bFade;
	}
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	if (button == 0) {
		switch (drawingStyle){
			case 0: VF.addInwardCircle((float)x, (float)y, 200, 0.3f);
				break;
			case 1: VF.addOutwardCircle((float)x, (float)y, 100, 0.3f);
				break;
			case 2: VF.addClockwiseCircle((float)x, (float)y, 100, 0.3f);
				break;
			case 3: VF.addCounterClockwiseCircle((float)x, (float)y, 100, 0.3f);
				break;
		}		
	} else {
		
		//particles.erase(particles.begin());
		//particle myParticle;
		//myParticle.setInitialCondition(x,y,0,0);
		//particles.push_back(myParticle);
		
		
	}
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}

//--------------------------------------------------------------
//
// from http://ilab.usc.edu/wiki/index.php/HSV_And_H2SV_Color_Space
//
//

ofColor testApp::HSVtoRGB( float hue, float sat, float val ){
	ofColor rgb;
	rgb.r = 0;
	rgb.g = 0;
	rgb.b = 0;
	
	//printf("H: %f, S:%f, V:%f \n", hue, sat, val );
	
	
	
	if ( val == 0 ){
		rgb.r = 0;
		rgb.g = 0;
		rgb.b = 0;
	}
	else if ( sat == 0 ){
		rgb.r = 0;
		rgb.g = 0;
		rgb.b = 0;
	}
	else {    
		//printf("HERE");
		float	hf = hue / 60.0;  
		//printf("HF: %f \n", hf);
		int		i  = (int) floor( hf );                              
		float	f  = hf - i;                                         
		float	pv  = val * ( 1 - sat );                                 
		float	qv  = val * ( 1 - sat * f );                             
		float	tv  = val * ( 1 - sat * ( 1 - f ) );                     
		
		if ( i == 0 ){                                                         
				rgb.r = val;                                                        
				rgb.g = tv;                                                       
				rgb.b = pv; 
		}
		else if ( i == 1 ){                                                         
				rgb.r = qv;                                                      
				rgb.g = val;                                                        
				rgb.b = pv;  
		}
		else if ( i == 2 ){                                                
				rgb.r = pv;                                                       
				rgb.g = val;                                                        
				rgb.b = tv;
		}
		else if ( i == 3 ){                                                      
				rgb.r = pv;                                                      
				rgb.g = qv;                                                       
				rgb.b = val;
		}                                                 
		else if ( i == 4 ){                                                         
				rgb.r = tv;                                                       
				rgb.g = pv;                                                       
				rgb.b = val;  
		}
		else if ( i == 5 ){                                                         
				rgb.r = val;                                                       
				rgb.g = pv;                                                      
				rgb.b = qv;
		}
		else if ( i == 6 ){                                                         
				rgb.r = val;                                                       
				rgb.g = tv;                                                       
				rgb.b = pv;                                                       
				return rgb;    
		}
		else if ( i == 7 ){rgb.r = val;                                                        
				rgb.g = pv;                                                       
				rgb.b = qv; 
		}
		
		//printf("R: %d, G:%d, B:%d \n", rgb.r, rgb.b, rgb.g);
		//return rgb;
		
	}
	
	rgb.r *= 255.0F;                                                        \
	rgb.g *= 255.0F;                                                        \
	rgb.b *= 255.0F;
	
	return rgb;
}
